Skip to content

Latest commit

 

History

History

2465

Folders and files

NameName
Last commit message
Last commit date

parent directory

..
 
 

You are given a 0-indexed integer array nums of even length.

As long as nums is not empty, you must repetitively:

  • Find the minimum number in nums and remove it.
  • Find the maximum number in nums and remove it.
  • Calculate the average of the two removed numbers.

The average of two numbers a and b is (a + b) / 2.

  • For example, the average of 2 and 3 is (2 + 3) / 2 = 2.5.

Return the number of distinct averages calculated using the above process.

Note that when there is a tie for a minimum or maximum number, any can be removed.

 

Example 1:

Input: nums = [4,1,4,0,3,5]
Output: 2
Explanation:
1. Remove 0 and 5, and the average is (0 + 5) / 2 = 2.5. Now, nums = [4,1,4,3].
2. Remove 1 and 4. The average is (1 + 4) / 2 = 2.5, and nums = [4,3].
3. Remove 3 and 4, and the average is (3 + 4) / 2 = 3.5.
Since there are 2 distinct numbers among 2.5, 2.5, and 3.5, we return 2.

Example 2:

Input: nums = [1,100]
Output: 1
Explanation:
There is only one average to be calculated after removing 1 and 100, so we return 1.

 

Constraints:

  • 2 <= nums.length <= 100
  • nums.length is even.
  • 0 <= nums[i] <= 100

Companies: Amazon

Related Topics:
Array, Hash Table, Two Pointers, Sorting

Similar Questions:

Solution 1. Sorting

// OJ: https://leetcode.com/problems/number-of-distinct-averages
// Author: github.com/lzl124631x
// Time: O(NlogN)
// Space: O(D) where D is the range of numbers
class Solution {
public:
    int distinctAverages(vector<int>& A) {
        sort(begin(A), end(A));
        unordered_map<double, int> m;
        for (int i = 0, j = A.size() - 1; i < j; ++i, --j) {
            m[((double)A[i] + A[j]) / 2]++;
        }
        return m.size();
    }
};

Solution 2. Counting Sort

// OJ: https://leetcode.com/problems/number-of-distinct-averages
// Author: github.com/lzl124631x
// Time: O(N)
// Space: O(D) where D is the range of numbers
class Solution {
public:
    int distinctAverages(vector<int>& A) {
        int cnt[101] = {};
        for (int n : A) ++cnt[n];
        int i = 0, j = 100;
        unordered_map<double, int> m;
        for (int c = A.size() / 2; c > 0; --c) {
            while (cnt[i] == 0) ++i;
            while (cnt[j] == 0) --j;
            m[((double)i + j) / 2]++;
            --cnt[i];
            --cnt[j];
        }
        return m.size();
    }
};